// PSU contorl API header
// Copyright (C) 2007 H.Momose
#ifndef __PSUFIRMUP_H__
#define __PSUFIRMUP_H__

#include "serial.h"

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define	PSU_SUCCESS				0
#define	PSU_INVALID_COM			1
#define PSU_ERROR_COM			2
#define PSU_INVALID_DEVICE		3
#define PSU_NOT_INITIALIZED		4



#ifdef __cplusplus
extern "C" {
#endif

int psu_firmup_init(const char *port);
void psu_firmup_fini();
int psu_firmup_getVersion(char *version);
int psu_firmup_erase();
int psu_firmup_write(const unsigned char *data);
int psu_firmup_quit();

#ifdef __cplusplus
}
#endif

#endif