// USBPSUAPPDlg.h : wb_[ t@C
//

#if !defined(AFX_USBPSUAPPDLG_H__A0DD20CA_9686_445F_AA84_C312B73D3F85__INCLUDED_)
#define AFX_USBPSUAPPDLG_H__A0DD20CA_9686_445F_AA84_C312B73D3F85__INCLUDED_

#include "PsuControl.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ColorStatic.h"
#include "serial.h"
#include "USBPSUConfig.h"

#include "clPlot.h"

/////////////////////////////////////////////////////////////////////////////
// CUSBPSUAPPDlg _CAO

class CUSBPSUAPPDlg : public CDialog
{
// \z
public:
	long m_prevSource;
	BOOL m_prevOutput;
	CBitmap m_bmOff;
	CBitmap m_bmOn;
	long m_logAppend;
	long m_logInterval;
	void CUSBPSUAPPDlg::Logger(double vset, double aset, double vnow, double anow, int ccmode, int output);
	psustat_st m_psustat;
	void SysLogMessage(const char *message);
	
	BOOL canSize;
	clPlot m_Plot;

	int bConnected;
	CUSBPSUAPPDlg(CWnd* pParent = NULL);	// W̃RXgN^
	virtual ~CUSBPSUAPPDlg();
	
// _CAO f[^
	//{{AFX_DATA(CUSBPSUAPPDlg)
	enum { IDD = IDD_USBPSUAPP };
	CColorStatic	m_cvdisp;
	CColorStatic	m_ccdisp;
	CProgressCtrl	m_pdisp;
	CColorStatic	m_adisp;
	CColorStatic	m_vdisp;
	//}}AFX_DATA

	USBPSUConfig	m_config;

	double			m_aset;
	double			m_vset;
	commio_t		*comm;

	CBrush			m_brEdit;
	COLORREF		m_clrEdit;

	CRichEditCtrl	m_richEdit;

	FILE			*m_logfile;

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CUSBPSUAPPDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CUSBPSUAPPDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnConnect();
	afx_msg void OnConfig();
	afx_msg void OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpin2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetVoltage();
	afx_msg void OnSetCurrent();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLogger();
	afx_msg void OnVmain();
	afx_msg void OnAmain();
	afx_msg void OnOutput();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_USBPSUAPPDLG_H__A0DD20CA_9686_445F_AA84_C312B73D3F85__INCLUDED_)
