// USBPSUConfig.cpp : Cve[V t@C
// Copyright (C) 2007 H.Momose

#include "stdafx.h"
#include "USBPSUAPP.h"
#include "USBPSUConfig.h"
#include "PsuControl.h"
#include "USBPSUFirmup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define APPNAME		"USBPSU"

/////////////////////////////////////////////////////////////////////////////
// USBPSUConfig _CAO


USBPSUConfig::USBPSUConfig(CWnd* pParent /*=NULL*/)
	: CDialog(USBPSUConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(USBPSUConfig)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	
	m_Current = 0;				// N̓dݒl
	m_Voltage = 0;				// N̓dݒl
	m_UpdateInterval = 500;		// j^XVԊu

    // init@Cst@CƓfBNgɍ쐬邪AWIN32APIł͂܂
	// Ȃ߁Ainit@CnhOOSS玝ĂCuŎ{
    
	// init@C΃pX쐬
	char path[MAX_PATH];
    ::GetModuleFileName(NULL, path, MAX_PATH -1);
    char* pdest = strrchr(path, '\\');
    pdest[1] = '\0';
    ::SetCurrentDirectory(path);
    strcat(path, _T("UsbPsu.ini"));
	
	// init@Cw
	m_ini.SetPathName(path);

	// |[g
	m_ini.GetString(APPNAME, "ComPort", m_ComPort, sizeof(m_ComPort) -1, "com1");

	//@Nڑ
	m_ConnectAtStart = m_ini.GetBool(APPNAME, "ConnectAtStart", false);

	// Xp
	m_PlotSpan = m_ini.GetInt(APPNAME, "PlotSpan", 180, 0);

	// Ot@Cۑ
	m_UseSysLogFile = m_ini.GetBool(APPNAME, "UseSysLogFile", false);

	// Ot@C
	m_ini.GetString(APPNAME, "SysLogFileName", m_SysLogFileName, sizeof(m_SysLogFileName) -1, "system.log");

	// d̃ItZbg
	m_OffsetAtt = m_ini.GetBool(APPNAME, "OffsetAtt", false);
}


void USBPSUConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(USBPSUConfig)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(USBPSUConfig, CDialog)
	//{{AFX_MSG_MAP(USBPSUConfig)
	ON_BN_CLICKED(IDC_SCANPORT, OnScanPort)
	ON_BN_CLICKED(IDC_EDITLOGFILE, OnChooseLogFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// USBPSUConfig bZ[W nh

BOOL USBPSUConfig::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// |[g
	CComboBox	*combo = (CComboBox*)GetDlgItem(IDC_SERPORT);
	combo->SetCurSel(atol(m_ComPort+3) -1);
	
	// Nڑ
	CheckDlgButton(IDC_CONNECTATSTART, m_ConnectAtStart);

	// o͗Xp
	combo = (CComboBox*)GetDlgItem(IDC_PLOTSPAN);
	switch(m_PlotSpan){

	case 60:
		combo->SetCurSel(0); break;
	
	case 120:
		combo->SetCurSel(1); break;

	case 180:
		combo->SetCurSel(2); break;

	case 240:
		combo->SetCurSel(3); break;

	default:
		combo->SetCurSel(0); break;
	}

	// Ot@Cۑ
	CheckDlgButton(IDC_USESYSTEMLOG, m_UseSysLogFile);

	// Ot@C
	SetDlgItemText(IDC_SYSLOGFILENAME, m_SysLogFileName);
	
	// ɐڑς݂ȂAXLO[AEg
	char buff[32];
	if(psu_getVersion(buff) == PSU_SUCCESS){
		// ڑς
		CButton *button=(CButton*)GetDlgItem(IDC_SCANPORT);
		button->EnableWindow(FALSE);
	}

	// d̃ItZbg
	CheckDlgButton(IDC_OFFSETATT, m_OffsetAtt);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void USBPSUConfig::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
	char buff[512];

	// Init@Co
	
	// |[g
	GetDlgItemText(IDC_SERPORT, m_ComPort, sizeof(m_ComPort) -1);
	m_ini.WriteString(APPNAME, "ComPort", m_ComPort);

	// Nڑ
	m_ConnectAtStart = IsDlgButtonChecked(IDC_CONNECTATSTART); 
	m_ini.WriteBool(APPNAME, "ConnectAtStart", m_ConnectAtStart);

	// Xp
	GetDlgItemText(IDC_PLOTSPAN, buff, sizeof(buff) -1);
	m_PlotSpan = atoi(buff);
	m_ini.WriteInt(APPNAME, "PlotSpan", m_PlotSpan, 0);

	// Ot@Cۑ
	m_UseSysLogFile = IsDlgButtonChecked(IDC_USESYSTEMLOG);
	m_ini.WriteBool(APPNAME, "UseSysLogFile", m_UseSysLogFile);

	// Ot@C
	GetDlgItemText(IDC_SYSLOGFILENAME, m_SysLogFileName, sizeof(m_SysLogFileName) -1);
	m_ini.WriteString(APPNAME, "SysLogFileName", m_SysLogFileName);

	// d̃ItZbg
	m_OffsetAtt = IsDlgButtonChecked(IDC_OFFSETATT); 
	m_ini.WriteBool(APPNAME, "OffsetAtt", m_OffsetAtt);

	CDialog::OnOK();
}

void USBPSUConfig::OnScanPort() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	for(int port = 1; port <= 32; port ++){
		char szPort[32];
		sprintf(szPort, "com%d",  port);
		if( psu_init(szPort) == PSU_SUCCESS){
			// I[v
			psu_fini();
			// R{{bNX̑I
			CComboBox *combo = (CComboBox*)GetDlgItem(IDC_SERPORT);
			combo->SetCurSel(port -1);
			// _CAO̕\
			char szMsg[256];
			sprintf(szMsg, "foCX %s Ō܂", szPort);
			MessageBox(szMsg, "OK", MB_OK | MB_ICONINFORMATION);
			break;
		}
	}
	if(port == 33){
		MessageBox("foCX܂","ERROR", MB_OK | MB_ICONERROR);
	}	
}

void USBPSUConfig::OnChooseLogFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog		fileDlg(
			FALSE,
			m_SysLogFileName,
			NULL,
			OFN_FILEMUSTEXIST | OFN_EXPLORER,
			_T("log file(*.log)|*.log|S(*.*)|*.*||")
		);

	if( fileDlg.DoModal() == IDOK){
		strcpy(m_SysLogFileName, LPCTSTR(fileDlg.GetPathName()) );
	}

	SetDlgItemText(IDC_SYSLOGFILENAME, m_SysLogFileName);
}

