// USBPSUFirmup.cpp : Cve[V t@C
// Copyright (C) 2007 H.Momose
// ChangeLog
//    Ver 1.0.1.0	t@[EFAXVvÕCv̂ߐV݂B

#include "stdafx.h"
#include "USBPSUAPP.h"
#include "USBPSUFirmup.h"
#include "PsuFirmup.h"
#include "USBPSUFirmupProg.h"
#include "hexreader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// USBPSUFirmup _CAO


USBPSUFirmup::USBPSUFirmup(CWnd* pParent /*=NULL*/)
	: CDialog(USBPSUFirmup::IDD, pParent)
{
	//{{AFX_DATA_INIT(USBPSUFirmup)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void USBPSUFirmup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(USBPSUFirmup)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(USBPSUFirmup, CDialog)
	//{{AFX_MSG_MAP(USBPSUFirmup)
	ON_BN_CLICKED(IDC_BUTTON1, OnChooseFirmFile)
	ON_BN_CLICKED(IDOK, OnFirmUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// USBPSUFirmup bZ[W nh

void USBPSUFirmup::OnChooseFirmFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// t@[QƂ\
	CFileDialog		fileDlg(
			TRUE,
			NULL,
			NULL,
			OFN_FILEMUSTEXIST | OFN_EXPLORER | OFN_HIDEREADONLY,
			_T("hex file(*.hex)|*.hex|S(*.*)|*.*||")
		);

	if( fileDlg.DoModal() == IDOK){
		strcpy(m_FirmFileName, LPCTSTR(fileDlg.GetPathName()) );
	}

	SetDlgItemText(IDC_FIRMFILENAME, m_FirmFileName);

}

void USBPSUFirmup::OnFirmUpdate() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	unsigned char newfirm[0x1000], buff[256];
	unsigned int offset;
	int	i, buff_len;
	USBPSUFirmupProg *prog = new USBPSUFirmupProg;
	
	// gp̃tbV0x3fffȂ̂ŁAŏ
	// PIC̖߂14bitȂ̂ŁASrbg𗧂Ă3fffɂȂ
	for(i = 0; i < sizeof(newfirm); i++){
		newfirm[i] = (i%2 == 0) ? 0x3f : 0xff;
	}

	// IHEXt@CI[v
	if( hex_open(m_FirmFileName) == FALSE){
		MessageBox(_T("w̃t@[EFAHEXt@CJ܂B"), "ERROR", MB_ICONERROR | MB_OK);
		goto done;
	}

	// t@[EFAHEXt@C[h
	while(1){
		buff_len = hex_read(&offset, buff);
		if(buff_len < 0 && buff_len != HEX_END){
			MessageBox(_T("t@[EFAHEXt@Cǂݍ݃G[łB"), "ERROR", MB_ICONERROR | MB_OK);
			goto done;
		}

		if(buff_len == HEX_END){
			break;
		}

		if(offset + buff_len > 0x1000){
			// HEXt@CɂConfigf[^EEPROMf[^A̓vOAhXɂ̂Ŗ
			continue;
		}


		// GfBAႤ̂œꊷȂRs[
		for(i = 0; i < buff_len; i++){
			newfirm[ ((offset+i)/2)*2 + (offset+i+1)%2] = buff[i];
		}
	}

	// t@[XV̒ʐMJn
	if(psu_firmup_init(m_ComPort) != PSU_SUCCESS){
		MessageBox(_T("t@[EFAXVvOƒʐMł܂B\n"\
			"t@[EFAXVvŐN菇ƃ|[gmFĂB"), "ERROR", MB_ICONERROR | MB_OK);
		goto done;
	}

	// tbV̏s
	if(psu_firmup_erase() != PSU_SUCCESS){
		MessageBox(_T("tbVɎs܂"), "ERROR", MB_ICONERROR | MB_OK);
		goto done;
	}

	// tbVփt@[

	// vOXo[̏
	prog->ShowWindow(SW_SHOWNORMAL);
	prog->SetRange(0x0200, 0x0800);
	UpdateData(FALSE);
	
	// 8oCgPʂœ]s
	for(offset = 0x0400; offset < 0x1000; offset += 8){
		MSG msg;

		// vOXo[̍XVA[hAhX\Ȃ̂2Ŋ
		prog->SetPos(offset/2);
		UpdateData(FALSE);
		
		if(psu_firmup_write(newfirm + offset) != PSU_SUCCESS){
			MessageBox(_T("t@[EFA]G[܂B"), "ERROR", MB_ICONERROR | MB_OK);
			goto done;
		}

		// ͎̏Ԃ̂ŏWindowAbvf[g
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			::TranslateMessage(&msg);
			if(msg.message == WM_PAINT){
				// ̓쒆͉ʍXVȊO͖
				::DispatchMessage(&msg);
			}
		}	
	}

	// t@[݊
	MessageBox(_T("t@[EFAXV͊܂B\n"\
		"_CAOƍXVvOIAvON܂B"),
		_T("t@[EFAXV"), MB_ICONINFORMATION | MB_OK);
	
	// t@[XVvOI
	psu_firmup_quit();

	CDialog::OnOK();

done:
	// HEXt@CN[Y
	hex_close();
	// t@[XV̒ʐMN[Y
	psu_firmup_fini();
	if(prog){
		// vOXo[̔j
		prog->DestroyWindow();
		delete prog;
	}
}

BOOL USBPSUFirmup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ

	m_FirmFileName[0] = 0;
	
	// ʐM|[g̕\
	SetDlgItemText(IDC_FIRMPORT, m_ComPort);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
