// Intel HEX file reader
// Copyright (C) 2007 H.Momose
// ChangeLog
//    Ver 1.0.1.0	t@[EFAXVvÕCv̂ߐV݁B

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "hexreader.h"
#include "comutil.h"

// HEXt@CtH[}bg̏
// http://www.pastelmagic.com/tips/hexform/hexform.html

static FILE *fp;

/*****************************************************************************
 * Function : hex_open
 * Argument : filename <= HEXt@C
 * Return   : TRUE
 *			: FALSE
 * Remarks  : 
 *****************************************************************************/
int hex_open(const char *filename)
{
	fp = fopen(filename, "r");
	if(fp){
		return(TRUE);
	}
	return(FALSE);
}


/*****************************************************************************
 * Function : hex_close
 * Argument : none
 * Return   : none
 * Remarks  : 
 *****************************************************************************/
void hex_close(void)
{
	if(fp){
		fclose(fp);
		fp = NULL;
	}
}


/*****************************************************************************
 * Function : hex_read
 * Argument : offset => AhXItZbg
 *			: data => ǂݏof[^
 * Return	: ǂݏof[^
 * Remarks  : `FbNT݂͂ĂȂ
 *****************************************************************************/
int hex_read(unsigned int *offset, unsigned char *data)
{
	unsigned char buff[256];
	unsigned int length, rectype, i;
	
	for( ; fgets(buff, sizeof(buff) -1, fp); ){

		for(i = 0; i < strlen(buff); i++){
			if(iscntrl(buff[i])){
				buff[i] = 0;
				break;
			}
		}

		if( strlen(buff) < 11){
			// Œł11oCg͂͂
			// 擪':' + f[^(2) + ItZbg(4) + R[h^Cv(2) + `FbNT(2) =11
			return(HEX_INVALID);
		}
		
		if( buff[0] != ':'){
			return(HEX_INVALID);
		}

		for(i=1; i < strlen(buff); i++){
			if(!isxdigit(buff[i])){
				return(HEX_INVALID);
			}
		}

		// f[^擾
		length = hex2int(buff[1]) * 0x10 + hex2int(buff[2]); 
		
		// ItZbgAhX擾
		*offset = hex2int(buff[3]) * 0x1000
				+ hex2int(buff[4]) *  0x100
				+ hex2int(buff[5]) *   0x10
				+ hex2int(buff[6]);

		// R[h^Cv擾
		rectype = hex2int(buff[7]) * 0x10 + hex2int(buff[8]);
		if(rectype == 01){
			// GhR[h
			return(HEX_END);
		}
		if(rectype != 0){
			// f[^R[hȊO͖
			continue;
		}

		for(i = 0; i < length; i++){
			*(data + i)  = hex2int(buff[9 + 2 * i]) * 0x10;
			*(data + i) += hex2int(buff[10 + 2 * i]);
		}

		return(length);
	}
	return(HEX_END);
}
