// LogFileDialog.cpp : Cve[V t@C
// Copyright(C) 2007 H.Momose

#include "stdafx.h"
#include "USBPSUAPP.h"
#include "LogFileDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// LogFileDialog

IMPLEMENT_DYNAMIC(LogFileDialog, CFileDialog)

LogFileDialog::LogFileDialog(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)
{
}


BEGIN_MESSAGE_MAP(LogFileDialog, CFileDialog)
	//{{AFX_MSG_MAP(LogFileDialog)
	ON_WM_DESTROY()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void LogFileDialog::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CFileDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	CComboBox	*combo = (CComboBox*)GetDlgItem(IDC_COMBO2);

	combo->AddString("1b");
	combo->AddString("10b");
	combo->AddString("1");
	combo->AddString("10");
	combo->AddString("1");

	switch(m_interval){
	case 1:
		combo->SetCurSel(0); break;

	case 10:
		combo->SetCurSel(1); break;

	case 60:
		combo->SetCurSel(2); break;

	case 600:
		combo->SetCurSel(3); break;

	case 3600:
		combo->SetCurSel(4); break;

	default:
		combo->SetCurSel(0); break;
	}

	CheckDlgButton(IDC_CHECKAPPEND, m_append);
}

void LogFileDialog::OnDestroy() 
{
	CFileDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	CComboBox	*combo = (CComboBox*)GetDlgItem(IDC_COMBO2);

	switch(combo->GetCurSel()){
	case 0:
		m_interval = 1; break;

	case 1:
		m_interval = 10; break;

	case 2:
		m_interval = 60; break;

	case 3:
		m_interval = 600; break;

	case 4:
		m_interval = 3600; break;

	default:
		m_interval = 1; break;
	}

	m_append = IsDlgButtonChecked(IDC_CHECKAPPEND);
}


